enchant();

var game = null;
var s=null;
var explist = new Array();
var lifemark=new Array();
var px = 160;
var py = 200;
var v = 2.5;
var life=5;
var t=new Sprite(64,64);


Bullet = Class.create(Sprite, {
    initialize: function(x, y, dx, dy) {
        Sprite.call(this, 64, 64);
        this.x = x;
        this.y = y;
        this.dx = dx;
        this.dy = dy;
        this.image = game.assets['texture0.png'];
        this.frame = 9;
        game.rootScene.addChild(this);
    },
    onenterframe: function() {
        this.x += this.dx;
        this.y += this.dy;
        if (this.x < -16 || this.x > 320-64+16) {
            this.dx *= -1;
            this.x += this.dx;
        }
        for (var i=0;i<explist.length;i++){
            if (this.within(explist[i],explist[i].scaleX*32)){
                var h=Math.atan2(this.y - explist[i].y, this.x - explist[i].x);
        		this.dx+=Math.cos(h)*50*explist[i].opacity;
                this.dy+=Math.sin(h)*50*explist[i].opacity;
                this.frame=10;
            }
        }
        if (this.y<0){
        	s.score+=(this.dx*this.dx+this.dy*this.dy)/10;
            game.rootScene.removeChild(this);
        }
        if (this.y>320){
            game.rootScene.removeChild(this);
            
            game.rootScene.removeChild(lifemark[life-1]);
            life-=1;
            
            if (life<0){
            	game.end(parseInt(s.score), 'You get '+parseInt(s.score)+' of sound(s) !!');
            }
        }
    }
});


Explode = Class.create(Sprite, {
    initialize: function(x, y) {
        Sprite.call(this, 64, 64);
        this.image = game.assets['texture0.png'];
        this.x = x - 32;
        this.y = y - 32;

        this.frame = 13;
        this.incScale = 0.2;
        this.scaleX = this.scaleY = 0;
        game.rootScene.addChild(this);
        explist.push(this);
    },
    onenterframe: function() {
        if (explist.indexOf(this)<0){
        	explist.push(this);
        }
        this.scaleX += this.incScale;
        this.scaleY += this.incScale;
        this.opacity *= 0.8;
        if (this.opacity < 0.1) {
            del=explist.indexOf(this);
            explist.splice(del,1);
            game.rootScene.removeChild(this);
        }
    }
});

window.onload = function() {
    game = new Game(320, 320);
    game.preload('texture0.png','icon0.png');
    game.onload = function() {
        game.rootScene.backgroundColor = '#000';
		game.rootScene.addChild(t);
        
        s = new ScoreLabel(10,10);
        s.score=0;
        game.rootScene.addChild(s);
        
        for(var i=0;i<life;i++){
        var l=new Sprite(16,16);
        	l.image=game.assets['icon0.png'];
        	l.frame=10;
            l.y=26;
            l.x=10+i*16;
        	lifemark.push(l);
            game.rootScene.addChild(l);
        }
        
        game.rootScene.on('touchstart', function(e) {
            var ex = new Explode(e.x, e.y);
        });
        game.rootScene.on('touchmove', function(e) {
            if (game.frame % 3 == 0) {
                var ex = new Explode(e.x, e.y);
            }
        });
        game.rootScene.on('enterframe', function() {
            if (game.frame % 30 == 0) {
                var x = Math.random() * (320-64);
                var h = Math.atan2(py - 0, px - x);
                var dx = Math.cos(h) * v*Math.random()*10;
                var dy = Math.sin(h) * v*Math.random()*10;
                var b = new Bullet(Math.random() * (320-64), 0, dx, dy);
            }
        });

    }
    game.start();
}